package at.jku.students.redblacktree;

import at.jku.ssw.graphviz.DotMakerRB;
import at.jku.ssw.redblacktree.RedBlackTreeNode;
import at.jku.ssw.redblacktree.impl.RedBlackTreeUtil;

public final class RedBlackTree {
	private final RedBlackTreeNode head;
	private final RedBlackTreeNode nil;

	public RedBlackTree() {
		this.nil = new RedBlackTreeNode(' ', null);
		this.nil.left = this.nil.right = this.nil;
		this.head = new RedBlackTreeNode(' ', nil);
	}

	/**
	 * Inserts the {@code char key} into this red black tree.
	 */
	public void insert(char key) {
		// TODO
	}

	public String makeDot() {
		return DotMakerRB.makeDot(head, nil);
	}

	/**
	 * Returns the first node of the tree (might be {@linkplain #isNil
	 * <em>nil</em>}).
	 */
	public RedBlackTreeNode getFirst() {
		return head.right;
	}

	/**
	 * Returns {@code true} if {@code node} is <em>nil</em>.
	 */
	public boolean isNil(RedBlackTreeNode node) {
		return node == nil;
	}

	@Override
	public String toString() {
		return RedBlackTreeUtil.toInOrderString(this);
	}
}
